# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc diff_c
##################################################
proc adv_c {generation velo dir} {
global lifefeld nmax newworld savefeld
global exec_dir rlist ncolors

# lifefeld enthaelt die Farbe
# savefeld enthaelt die Konzentrationen

# Maximale Konzentration ncolors
# wird mit Mausklick gesetzt


# velo: Advektionsgeschwindigkeit (positiv, da upstream Berechnung)
# dir: Richtung 1-8 (Nachbarschaft im Uhrzeigersinn)

set clist "$nmax $newworld $velo $dir"

# Retten der alten Werte

for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist $savefeld($i,$j)
   }
}
set rlist [eval exec $exec_dir/cadv $clist]
# puts $clist
# puts ""
# puts $rlist
#Berechnen der neuen Werte
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
     set wert [lindex $rlist [expr $i*($nmax+1)+$j]]
     set savefeld($i,$j) $wert
     set col [expr int($wert)]
     if {$col > $ncolors} {set col $ncolors}
     set lifefeld($i,$j) $col

     }
   }
}

