# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc Kaefer_c
# DIE zentrale Berechnung
##################################################
proc beetle_c {generation} {
global lifefeld nmax newworld savefeld baumfeld
global exec_dir rlist ncolors

set r 		54.75;   # Vermehrung in "altem" Wald in 1/y = 0.15 1/d
set K		5000.0;  # Kapazität der Käfer in Anzahl/Ar
set mue		36500.0; # Verminderung durch Frass in 1/(y*Ar) = 100 1/(Ar*d)
set M		500.0;   # notwendige Käferdicht für Vermehrung in Anzahl/Ar
set N		3.0;     # Exponent

set alfa	0.15;    # 0.04; % Altern des Waldes
set beta	1.7;     # Schädigung des Waldes

set eps0	1.0;     # Anteil, der max. diffundiert in 1/Jahr
set epsr	0.9;     # Richtungsparameter


set salter	0.57;     # Bäume älter als schlagwert werden geschlagen
set rs		1.0;      # Schlageffizienz

set schlagalter 500
set schlag 0
#if {$generation>$schlagalter} {set schlag 1}

set clist "$nmax $newworld $schlag $eps0 $epsr $r $rs $mue $alfa $beta $K $M $N $salter"

# Retten der alten Werte

for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist $savefeld($i,$j)
   }
}
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist $baumfeld($i,$j)
   }
}


set rlist [eval exec $exec_dir/cbeetle $clist]

#Berechnen der neuen Werte
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
     set wert [lindex $rlist [expr $i*($nmax+1)+$j]]
     set savefeld($i,$j) $wert
     set col [expr int($ncolors*$wert/$K)]
     if {$col > $ncolors} {set col $ncolors}
     set lifefeld($i,$j) $col
     set wert [lindex $rlist [expr $i*($nmax+1)+$j+($nmax+1)*($nmax+1)]]
     set baumfeld($i,$j) $wert
     }
   }

}

