# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_fix {para dt} {
global maxsteps limit which
global exec_dir
global a b c d e
global functiony
global aymin aymax
set y0 0.2

set a $para
set commandy [makecommand $functiony]

set list ""
set store [expr $maxsteps-$maxsteps/4.0]
set y $y0


for {set i 0} {$i<$maxsteps/$dt} {incr i} {

       set y [expr $dt*[expr $commandy]]
       if {$i>$store} { 
          lappend list $y
          set aymin [min $aymin $y]
          set aymax [max $aymax $y]
       }
}

return [lsort -unique $list]

}

proc calc_par {dt} {
global can
global xmin xmax xdelt pxmin pxdelt
global ymin ymax ydelt pymin pydelt
global maxsteps maxstep minlambda maxlambda
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global limit showbifu
global aymin aymax
init_bifu


if {$dt==0} {set dt 1; set init 1}  else {set init 0}
set xmin $minlambda
set xmax $maxlambda
set xdelt [expr $maxlambda -$minlambda]
set limit [expr $maxsteps/4]

set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin 0.0
set ymax 1.5
set ydelt 1.5

set aymin inf
set aymax -inf


set item [.ov.plot create text [expr $can/2] 20 -text "Parameter dependency" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$maxsteps iterations; Parameter range $minlambda $maxlambda" \
             -font $plotFontS -anchor c]

update
set actmin $minlambda
set actmax $maxlambda

for {set i 0} {$i<=$pxdelt} {incr i} {
    set para($i) [expr $actmin+$i*($actmax-$actmin)/double($pxdelt)]
        set points($i) [calc_fix $para($i) $dt]
}

set ymin $aymin
set ymax $aymax
set ydelt [expr $ymax-$ymin]
 
if {$init == 0 && $showbifu==1} { 
    
    
for {set i 0} {$i<=$pxdelt} {incr i} {
foreach y $points($i) {
       set item [eval {.ov.plot create line} [nnx $para($i)] [nny $y] [expr [nnx $para($i)]+1] [nny $y]]
    }

update
    
}
}

}


