# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc it_cantor {number xanf yanf xend yend} {
global nmax mode
global w3h
global help

set c .ov.plot


    set item [eval {$c create line} [nnx $xanf] [expr [nny $yanf]+$number*20] \
                                    [nnx $xend] [expr [nny $yend]+$number*20]]
    $c addtag curve withtag $item
    update

if {$number < $nmax} { 
   set xdelt [expr ($xend-$xanf)/3.0]

      set xmid1 [expr $xanf+ $xdelt]
      set xmid2 [expr $xmid1 + $xdelt]


   incr number
   it_cantor $number $xanf $yanf $xmid1 $yanf
   it_cantor $number $xmid2 $yanf $xend $yanf
}

}

proc calc_cantor {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global w3h
global can

set w3h [expr sqrt(3)/2.0]

set xanf 0
set yanf 0.5
set xend 1
set yend 0.5

set xmin -0.5
set xdelt 2.0
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -1.0
set ydelt 2.0

erase .ov.plot all
     it_cantor 0 $xanf $yanf $xend $yend

set item [.ov.plot create text [expr $can/2] 20 -text "Cantor Set" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax iterations, mode: $mode" \
             -font $plotFontS -anchor c]

}


