# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg


proc calc_sunflower {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global lamda s
global can

set xmin -100
set xdelt 200
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -100
set ydelt 200


erase .ov.plot all

set epsilon $s
set theta [expr $lamda+3.1415927*(sqrt(5)-1)*$s]
set theta [expr 3.1415927*$lamda/180.0]; # Winkel in Bogenmaß
set ra 0
set phia 0

set x  [expr $ra*cos($phia)]
set y  [expr $ra*sin($phia)]

for {set i 0} {$i <=$nmax} {incr i} {    
  
   set rn    [expr $ra+$i*$epsilon]
   set phin [expr $phia+$i*$theta]
   
   set x [expr $rn*cos($phin)]
   set y [expr $rn*sin($phin)]
   
   set item [eval {.ov.plot create oval} [nnx $x]  [nny $y]  [expr [nnx $x]+1] [expr  [nny $y] +1]]
   
}

set item [.ov.plot create text [expr $can/2] 20 -text "Sunflower"  -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax points"  -font $plotFontS -anchor c]

}


