# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc scalx {x} {
global oldxsize xmin xmax
global offsetx 

set x [expr 1.0*$x-$offsetx]
set xd [expr $xmax-$xmin]
return [expr $xmin+$xd*$x/(1.0*$oldxsize)]
}

proc scaly {y} {
global oldysize ymin ymax
global offsety

set y [expr  1.0*$y-$offsety]
set yd [expr $ymax-$ymin]
return [expr $ymin+$yd*($oldysize-$y)/ (1.0*$oldysize)]
}

proc setcoo {} {
global xc yc boldFontN
global showcoor can

.ov.plot delete coo

set x $xc
set y $yc

set xc [scalx $xc]
set yc [scaly $yc]


if {$showcoor==1} {
if {$x <100} {set ancx w} else {set ancx e}
if {$y >$can-20} {set ancy s} else {set ancy n}


set item [.ov.plot create text $x $y -text "([format "%5.2f" $xc],[format "%5.3f" $yc])" \
           -anchor $ancy$ancx -font $boldFontN -fill red]

.ov.plot addtag coo withtag $item

}


}

proc scalcoo {} {
global cminx cmaxx cminy cmaxy
global minx maxx miny maxy

set minx [scalx $cminx]
set miny [scaly $cminy]
set maxx [scalx $cmaxx]
set maxy [scaly $cmaxy]

}

