# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc customtool {} {
global env exec_dir pwd home toolflag storedir install_dir tclsrc_dir

global can
global filename
global toolflag data
global lfont textFont infoFont

global defaulteditor
global defaultstoredir
global defaultcan
global simtype

toplevel .custom

wm title .custom {Tiger Graphics Mathtool Options}
wm geometry .custom "+200+100"
#wm sizefrom .custom user
set toolflag custom
set lfont $infoFont
set textFont $lfont

set defaulteditor ""
set defaultcan $can

readdefaults

set pady 5
set width 50



# Initializing of the buttons
##############################
frame .custom.c1
pack .custom.c1 -pady 20

label .custom.c1.edtext -text " Editor" -font $lfont
pack .custom.c1.edtext -side left -pady $pady

entry .custom.c1.ed -width $width -bd 2 -textvariable defaulteditor -font $lfont
pack  .custom.c1.ed -side left

button  .custom.c1.sed -text {  Browse  } -font $lfont\
-command { set defaulteditor [fileselect  "Select Editor Program" "*.exe" . open];raise .custom }
pack  .custom.c1.sed -side left

button  .custom.c1.empty -text {  Reset  } -font $lfont -command { set defaulteditor ""}
pack  .custom.c1.empty -side left

# Initializing of the buttons
##############################
frame .custom.c2
pack .custom.c2 -pady 20

label .custom.c2.edtext -text " Browser" -font $lfont
pack .custom.c2.edtext -side left -pady $pady

entry .custom.c2.ed -width $width -bd 2 -textvariable defaultbrowser -font $lfont
pack  .custom.c2.ed -side left

button  .custom.c2.sed -text {  Browse  } -font $lfont\
-command { set defaultbrowser [fileselect  "Select Browser Program" "*.exe" . open];raise .custom }
pack  .custom.c2.sed -side left

button  .custom.c2.empty -text {  Reset  } -font $lfont -command { set defaultbrowser ""}
pack  .custom.c2.empty -side left


# Initializing of the buttons
##############################
frame .custom.c3
pack .custom.c3 -pady 20

label .custom.c3.edtext -text " Store Directory" -font $lfont
pack .custom.c3.edtext -side left -pady $pady

entry .custom.c3.ed -width $width -bd 2 -textvariable defaultstoredir -font $lfont
pack  .custom.c3.ed -side left

button  .custom.c3.sed -text {  Browse  } -font $lfont\
-command { set defaultstoredir [dirselect  "Select Store Directory" $defaultstoredir ]
                    if ![file exist $defaultstoredir] {file mkdir $defaultstoredir}
                    raise .custom 
                 }
pack  .custom.c3.sed -side left

button  .custom.c3.empty -text {  Reset  } -font $lfont -command { set defaultstoredir $home}
pack  .custom.c3.empty -side left


##############################

frame .custom.can
pack .custom.can -pady 20

label .custom.can.text  -font $lfont -text "Canvas Size"
pack .custom.can.text -side left -pady 5


radiobutton .custom.can.400  -font $lfont -variable defaultcan \
              -text "400x400"  -value 400
radiobutton .custom.can.500  -font $lfont -variable defaultcan \
              -text "500x500"  -value 500
radiobutton .custom.can.600  -font $lfont -variable defaultcan \
              -text "600x600"  -value 600
radiobutton .custom.can.700  -font $lfont -variable defaultcan \
              -text "700x700"  -value 700
radiobutton .custom.can.800  -font $lfont -variable defaultcan \
              -text "800x800"  -value 800
radiobutton .custom.can.1000  -font $lfont -variable defaultcan \
              -text "1000x1000"  -value 1000

pack .custom.can.400 -side left -pady 2
pack .custom.can.500 -side left -pady 2
pack .custom.can.600 -side left -pady 2
pack .custom.can.700 -side left -pady 2
pack .custom.can.800 -side left -pady 2
pack .custom.can.1000 -side left -pady 2


#############################
global filename allbuts

frame .custom.button
pack .custom.button -side bottom

button  .custom.button.cancel -text {  Cancel } -font $lfont -command {
destroy .custom
enablemenu}
pack  .custom.button.cancel -side left

button  .custom.button.exit -text {  Apply  & Exit} -font $lfont -command {

writedefaults
readdefaults
destroy .custom
enablemenu}

pack  .custom.button.exit -side left

#button  .custom.button.tatze -bitmap @$moviehome/icons/tinylogo.pic -command {tatzetool}
#pack  .custom.button.tatze -side left

update idletasks
}

