# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc fileselect {title type dir operation {initfile FRACFUNCTION}} {

global storedir



switch $type {

ifs { set types {
	{"IFS files"	{.ifs}	}
	{"All files"		*}
       }
     }

tgf  { set types {
	{"Function files"	{.tgf}}
	{"All files"		*}
       }
       set dir $storedir
     }

tgp  { set types {
	{"Function files"	{.tgp}}
	{"All files"		*}
       }
       set dir $storedir
     }

tgd  { set types {
	{"Function files"	{.tgd}}
	{"All files"		*}
       }
       set dir $storedir
     }
tgt  { set types {
	{"Function files"	{.tgt}}
	{"All files"		*}
       }
       set dir $storedir
     }

lif  { set types {
	{"Automate files"	{.lif}}
	{"All files"		*}
       }
       set dir $storedir
     }


c    { set types {
	{"C Source Files"	{.c}}
	{"All files"		*}
       }   
     }

ps    { set types {
	{"PS Files"	{.ps .eps}}
	{"All files"		*}
       }
     }


default { set types {
	   {"All files"		*}
	   {"Tcl Scripts"		{.tcl}}
	   {"C Source Files"	{.c .h}}
        }   
    }
}

global tk_strictMotif
set tk_strictMotif 0
    if {$operation == "open"} {
	set file [tk_getOpenFile -title $title -filetypes $types \
                 -initialdir $dir]
    } else {
	set file [tk_getSaveFile -filetypes $types -title $title \
	    -initialdir $dir -initialfile $initfile -defaultextension .$type]
    }
return $file
}

proc dirselect {title dir {exist 1}} {

global tk_strictMotif
set tk_strictMotif 0
set dir [tk_chooseDirectory -initialdir $dir -title $title -mustexist $exist]
    }
return $dir
}


