# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc min {a b} {

if {$a <= $b} {set c $a} else {set c $b}
return $c
}

proc max {a b} {

if {$a  >= $b} {set c $a} else {set c $b}
return $c
}

proc zipp {a b} {
set newlist {}
set la [llength $a]
set lb [llength $b]

set ll [min $la $lb]

for {set i 0} {$i < $ll} {incr i} {
   append newlist [lindex $a $i] " " [lindex $b $i] " "
}
return $newlist
}


proc primfac {a} {

set j 2
set prim {}

set zahl 1.0
set afrac $a

while {$zahl != $a} {
  scan $afrac %u afrac
  while {[expr $afrac % $j] == 0} {
    append prim $j " "
    set zahl [expr $zahl*$j]
    set afrac [expr $afrac/$j]
  }
  incr j
}


return $prim
}
 

proc kgv {a1 a2} {

set kgv 1.0
set p1 [primfac $a1]
set p2 [primfac $a2]

foreach fac $p1 {
  set ind [lsearch $p2 $fac]
  if {$ind != -1} {set p2 [lreplace $p2 $ind $ind]}
}
set facs [concat $p1 $p2]
foreach j $facs {
  set kgv [expr $kgv*$j]
}
return $kgv
}


proc lmean {list} {

set len [llength $list]
set lm 0
if {$len !=0} {
  foreach a $list {
     set lm [expr $a + $lm]
  }
  set lm [expr $lm/$len]
} else {
  set lm 0
}
return $lm
}

proc lmed {list} {
set len [llength $list]
set list [lsort -real $list]
if {$len !=0} {

   if { {$len%2}!=0 } {
      scan [expr ($len-1)/2] %d ind
      set lm [lindex $list $ind]
   } else {
      scan [expr ($len-2)/2] %d ind
      set lm [expr ([lindex $list $ind]+[lindex $list [expr $ind+1])/2]
   }
} else {
  set lm 0
}
return $lm
}

proc lstd {list} {
set len [llength $list]
set lm 0
if {$len > 1} {
  set mean [lmean $list]

  foreach a $list {
     set lm [expr $lm + ($a -$mean)*($a -$mean)]
  }
  set lm [expr sqrt($lm/($len-1))]
} else {
  set lm 0
}
return $lm
}

proc lmax {list} {
set len [llength $list]
if {$len !=0} {
  set lm [lindex $list 0]
  foreach a $list {
     set lm [max $a $lm]
  }
} else {
  set lm 0
}
return $lm
}

proc lmin {list} {
set len [llength $list]
if {$len !=0} {
  set lm [lindex $list 0]
  foreach a $list {
     set lm [min $a $lm]
  }
} else {
  set lm 0
}
return $lm
}
proc lsum {list} {
set len [llength $list]
if {$len !=0} {
  set lm [lindex $list 0]
  foreach a $list {
     set lm [expr $a+$lm]
  }
} else {
  set lm 0
}
return $lm
}
