# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_det {} {
global a b c d e f det 

if ![info exists det] {
set sum 0.0
for {set i 1} {$i<=4} {incr i} {
  set det($i) [expr abs($a($i)*$d($i)-$b($i)*$c($i))+0.01]
  set sum [expr $sum+$det($i)]
}
for {set i 1} {$i<=4} {incr i} {set det($i) [expr $det($i)/$sum]}
}
}

proc calc_ifs {} {
global xmin xmax ymin ymax
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global iter
global a b c d e f det con
global which
global xdelt pxmin pxdelt
global ydelt pymin pydelt
global stop every
global exec_dir
global can

set stop 0

set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set xdelt [expr double(1.0*$xmax-1.0*$xmin)]
set ydelt [expr double(1.0*$ymax-1.0*$ymin)]


set x 1.0
set y 1.0
erase .ov.plot all

set item [.ov.plot create text [expr $can/2] 20 -text $which \
             -font $boldFontN -anchor c]

set item [.ov.plot create text  [expr $can/2] 40 -text "$iter points" \
             -font $plotFontS -anchor c]

#calc_det

set w1 $det(1); set w2 [expr $w1+$det(2)]
set w3 [expr $w2+$det(3)];set w4 [expr $w3+$det(4)]

set length [expr $iter+100]
randomInit [pid]
set ran [random]
set ranlist [exec $exec_dir/random $ran $length]

for {set i 0} {$i<[expr $iter+100]} {incr i} {
if {$stop!=-1} {

    set ran [lindex $ranlist $i]
    set xa $x
    set ya $y

    set system 0
    if {$ran<$w1} {set system 1} else {
       if {$ran<$w2} {set system 2} else {
          if {$ran<$w3} {set system 3} else {
             if {$ran<$w4} {set system 4}}}}

    if {$system==0} {
    
       set con1 [expr double([random])]
       set con2 [expr double([random])]
    }

   if {$system!=0} {
      set x [expr $a($system)*$xa+$b($system)*$ya+$e($system)]
      set y [expr $c($system)*$xa+$d($system)*$ya+$f($system)]
   } else {
     if {$which=="chess"} {
        if {[expr $con2 + $con1] <= 1.0} {
           set x [expr 0.5*$con1-0.5*$con2]
           set y [expr 0.3*$con1+0.3*$con2]
        } else {
           set x [expr 0.5*$con1-0.5*$con2]
           set y [expr 0.2*$con1+0.2*$con2+0.1]
        }
     } else {
         set x [expr $con(a)*$con1+$con(b)*$con2+$con(e)]
         set y [expr $con(c)*$con1+$con(d)*$con2+$con(f)]
     }
   }
}
   if {$i>100} {
      set px [nnx $x]
      set py [nny $y]
      set item [.ov.plot create line $px $py [expr $px+1] [expr $py+1]]
      if {$every==1} {update}
   }

}
}


