# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_mandel {} {
global xmin xmax ymin ymax
global nmax
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global storedir install_dir exec_dir
global ulx uly lrx lry oldxsize oldysize
global iter
global bindflag
global can

set plotFont $plotFontN

.ov.plot config -cursor watch
update


if { $bindflag == 1 } {
set ulx [expr $ulx-50]
set uly [expr $uly-50]
set lrx [expr $lrx-50]
set lry [expr $lry-50]
set bindflag 0
}


erase .ov.plot all

set item [.ov.plot create text [expr $can/2] 20 -text "Mandelbrot's Set" \
             -font $boldFontN -anchor c]

if ![file exists $storedir/temp] {file mkdir $storedir/temp}

set scal [exec $exec_dir/mandel $xmin $xmax $ymin $ymax $ulx $lrx $uly $lry $oldxsize $oldysize $iter [expr $can - 100] $install_dir/colors/redtemp.dat $storedir/temp/mandel.ppm]


set xmin [lindex $scal 0]
set xmax [lindex $scal 1]
set ymin [lindex $scal 2]
set ymax [lindex $scal 3]
set oldxsize [lindex $scal 4]
set oldysize [lindex $scal 5]
set ulx 0
set uly 0
set lrx $oldxsize
set lry $oldysize

set item [.ov.plot create text [expr $can/2] [expr $can - 20] -text "xmin=$xmin  ymin=$ymin  xmax=$xmax  ymax=$ymax" \
             -font $plotFontS -anchor c]

image create photo mandel -gamma 3.0 -file $storedir/temp/mandel.ppm

set item [.ov.plot create image 50 50 -image mandel -anchor nw]

.ov.plot config -cursor top_left_arrow

update


}


