# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc mandelControl {} {
global can ovc
global boldFontN

#toplevel $ovc
#wm title $ovc { Control panel }
#wm geometry $ovc "+660+250"


set ovc .ov.right.control

frame $ovc
pack $ovc

global mode nmax
global which name
global areaX1 areaY1 areaX2 areaY2
global ulx uly lrx lry
global julx july
global iter
global scal
global xc yc
global bindflag
global offsetx offsety
global showcoor
global storedir

set showcoor 1
set offsetx 50
set offsety 50

set nmax 0
set which mandel

set iter 1000

set areaX1 0
set areaY1 0
set areaX2 0
set areaY2 0


bind .ov.plot <1> "itemMark .ov.plot %x %y; set ulx %x; set uly %y; set bindflag 1"
bind .ov.plot <B1-Motion> "itemStroke .ov.plot %x %y; set lrx %x; set lry %y; set bindflag 1;raisewindows"
bind .ov.plot <3> "itemMark .ov.plot %x %y; set julx %x; set july %y; calc_jset;raisewindows"
bind .ov.plot <Motion> "itemMark .ov.plot %x %y; set xc %x; set yc %y;setcoo"

# Initializing of sliders
#------------------------
frame $ovc.left
pack $ovc.left

menubutton $ovc.left.which -text Fractal -menu $ovc.left.which.menu -font $boldFontN -relief raised -pady 10
pack $ovc.left.which
set m [menu $ovc.left.which.menu -tearoff 0]

set labels {newton mandel}
set name(newton) "Newton Roots"
set name(mandel) "Mandelbrot's Set" 

foreach lab $labels {
  $m add radio -label $name($lab) -variable which -value $lab  -font $boldFontN \
        -command {setname $ovc.left.which  $name($which);init_$which;calc_$which}
}


scale $ovc.left.xmin -from 0 -to 25000 \
      -variable iter \
      -length 200 \
      -orient horizontal -label "Number of iterations" \
      -tickinterval 10000 -showvalue true -resolution 100 \
      -bigincrement 5000 -font $boldFontN
pack $ovc.left.xmin -fill x

frame $ovc.right
pack $ovc.right

frame $ovc.right.misc
pack $ovc.right.misc -side bottom -pady 10

button $ovc.right.misc.calc -text {Calculate}  -font $boldFontN \
       -command {calc_$which}
pack $ovc.right.misc.calc -fill x
 
button $ovc.right.misc.ps -text {save & print}  -font $boldFontN \
       -command {savegif $storedir/temp/$which.gif;printout}
pack $ovc.right.misc.ps -fill x
 
update
update idletasks
$m invoke $name($which)


}
