# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc axes {{c .ov.plot}} {

global can toolflag
global pxmin pxmax pymin pymax pxdelt pydelt
global xmin xmax ymin ymax xdelt ydelt
global minx miny
global plotFontN boldFontN

if {$toolflag=="plot"} {set color grey} else {set color red}

# x Axis by zero
#--------------------------
set item [$c create line $pxmin [nny 0] $pxmax [nny 0] -width 1.0 -fill $color]
$c addtag axis withtag $item

# Plotting of y-axis
#--------------------------

set item [$c create line [nnx 0] $pymin [nnx 0] $pymax -width 1.0 -fill $color]
$c addtag axis withtag $item

# Plotting of x-axis labels
#--------------------------
set imin 0
set anz 10
set anz  [expr int($xdelt)] 

while {$anz <10} {set anz [expr $anz*2]}
# while {$anz >10} {set anz [expr $anz/2]}


for {set i 0} {$i <= $anz} {incr i} {

     if {$xmax>1} {
         set xlabel [expr int($xmin + $i*$xdelt/$anz)]
         set xtext [string trim [format "%3d" $xlabel]]
    } else {
         set xlabel [expr $xmin + $i*$xdelt/$anz]
         set xtext [string trim [format "%10.3g" $xlabel]]
    }
     set xoff [nnx $xlabel]
 
 
      if {$ymin>=0} {
          set pos $ymin
          set moff -5
          set loff -13
     } else {
         set pos 0
         set moff 5
         set loff 13
     }


     set item [$c create line $xoff [nny $pos] $xoff [expr [nny $pos]+$moff] -width 1 -fill $color]
     $c addtag axis withtag $item

    
     set item [$c create text $xoff [expr [nny $pos]+$loff] -text $xtext -anchor c -font $plotFontN -fill $color]
     $c addtag axis withtag $item

}

  # Plotting of y-axis labels
  #--------------------------

set anz  [expr int($ydelt)] 

while {$anz <10} {set anz [expr $anz*2]}
# while {$anz >10} {set anz [expr $anz/2]}


for {set i 0} {$i <= $anz} {incr i} {
    
    
    if {$ymax>1} {
         set ylabel [expr int($ymin + $i*$ydelt/$anz)]
         set ytext [string trim [format "%3d" $ylabel]]
    } else {
         set ylabel [expr $ymin + $i*$ydelt/$anz]
         set ytext [string trim [format "%10.3g" $ylabel]]
    }
    

    set yoff [nny $ylabel]
 
      if {$xmin>=0} {
          set pos $xmin
          set moff 5
          set loff 10
          set anchor w
     } else {
         set pos 0
         set moff -5
         set loff -10
         set anchor e
     }

    set item [$c create line [expr [nnx $pos]+$moff] $yoff [nnx $pos] $yoff -width 1 -fill $color]
    $c addtag axis withtag $item
    
    set item [$c create text [expr [nnx $pos] +$loff] $yoff \
                  -text [string trimleft $ytext] -anchor $anchor -font $plotFontN -fill $color]
    $c addtag axis withtag $item

}

if {$toolflag=="plot"} {
# Bindings for horizontal line
#-----------------------------

bind $c <Button-1> "xlineDown $c %x %y"
bind $c <B1-Motion> "xlineMotion $c %x %y"
bind $c <ButtonRelease-1> "xlineRelease $c"


# Bindings for vertical line
#-----------------------------

bind $c <Button-3> "ylineDown $c %x %y"
bind $c <B3-Motion> "ylineMotion $c %x %y"
bind $c <ButtonRelease-3> "ylineRelease $c"
}
}



