# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc plotfunc {} {
global can
global xmin xmax xdelt pxmin pxmax pxdelt
global ymin ymax ydelt pymin pymax pydelt
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global function command fname
global minx maxx miny maxy
global xstates
global a b c d e
global showfunc
global axmin axmax aymin aymax
global agrflag
global fanz

set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]

set_plot

set color(1) black
set color(2) red
set color(3) seagreen
set color(4) blue
set color(5) magenta
set color(6) orange

set width 1

set yval 0
set yoff 20

axes

set axmin $minx
set axmax $maxx

set aymin inf
set aymax -inf

for {set i 1} {$i<=$fanz} {incr i} {
 set xout ""
 set yout ""
 if {$showfunc($i)==1} {
   set command($i) [makecommand $function($i)]

   set x $xmin
   #set y [expr double($command($i))]
    if {[catch { expr double($command($i)) } result]} {
    	textinfo "Fehler bei $x: $result"
        set y 0
    } else {
    	set y $result
    }

   for {set j 0} {$j<=$can} {incr j} {
    set xa $x
    set ya $y

    lappend xout $xa
    lappend yout $ya

    set x [expr $xmin +$j*$xdelt/$can]
    if {[catch { expr double($command($i)) } result]} {
    	textinfo "Fehler bei $x: $result"
    } else {
    	set y $result
    }

set aymin [min $aymin $y]
set aymax [max $aymax $y]

#    set y [expr double($command($i))]


    .ov.plot create line [nnx $xa] [nny $ya] [nnx $x] [nny $y]\
                       -tag richt -fill $color($i) -width $width
   }
    set yval [expr $yval+$yoff]
   .ov.plot create text 15 $yval -text "$fname($i)(x)= $function($i)"  -font $boldFontN -anchor w -tag title -fill $color($i)

if {$agrflag==1} {
   if {$i==1} { xv_open_graph 0  $axmin $axmax $aymin $aymax  " " xx}
   xv_set_num 0 [expr $i-1] $yout $function($i) 0  $xout
}

 }



}
.ov.plot create text 15 [expr $yval+$yoff] -text "a=$a b=$b c=$c d=$d e=$e"  -font $boldFontN -anchor w -tag title
.ov.plot create text 15 [expr $yval+2*$yoff] -text "($xmin,$xmax)x($ymin,$ymax)" -font $boldFontN -anchor w -tag title
.ov.plot create rect 10 10 200 [expr $yval+3*$yoff]  -tag title

}


