# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc plotsquare {} {
global can
global tmin tmax
global xmin xmax xdelt pxmin pxmax pxdelt
global ymin ymax ydelt pymin pymax pydelt
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global function command fname
global a b c d e
global axmin axmax aymin aymax
global vecx vecy

set axmin inf
set axmax -inf
set aymin inf
set aymax -inf



set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]



set color(1) black
set color(2) red
set color(3) seagreen
set color(4) orange

set width 2

set yval 0
set yoff 20

axes

for {set i 0} {$i<=3} {incr i} {
    set j [expr int(fmod($i+1,4))]
    
    plotvector $vecx($i) $vecy($i) $vecx($j) $vecy($j) $color([expr $i+1])
 
}
set EW [calc_ew $a $b $c $d]
set sp [lindex $EW 4]
set det [lindex $EW 5]
set EW1 [lindex $EW 0]
 set EW2 [lindex $EW 1]
 set EV1 [lindex $EW 2]
  set EV2 [lindex $EW 3]
  
   
 set yval [expr $yval+$yoff]
.ov.plot create text 10 [expr $yval+$yoff] -text "$a $b"  -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+2*$yoff] -text "$c $d" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+3*$yoff] -text "spur = $sp " -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+4*$yoff] -text "det = $det" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+5*$yoff] -text "EW1 = $EW1" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+6*$yoff] -text "EW2 = $EW2" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+7*$yoff] -text "EV1 = $EV1" -font $boldFontN -anchor w -tag title
.ov.plot create text 10 [expr $yval+8*$yoff] -text "EV2 = $EV2" -font $boldFontN -anchor w -tag title

}


