# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc scaleaxes {mode} {
global can

global textFont boldFontN ovc toolflag
global comlab comname
global minx miny maxx maxy mint maxt

global stmin stmax sxmin sxmax symin symax

toplevel .com

if {$mode==0} {
  set stmin [format %6.3f $mint]
  set stmax [format %6.3f $maxt]
} else {
  set stmin 0
  set stmax 10
}

set sxmin [format %6.3f $minx]
set sxmax [format %6.3f  $maxx]
set symin [format %6.3f  $miny]
set symax [format %6.3f $maxy]


wm title .com {Scale Control}
wm geometry .com "+[expr $can/2]+[expr $can/2]"

$ovc.right.misc.scale configure -state disabled


if {$mode==0} {
  frame .com.t
  pack .com.t

  label .com.t.min -text tmin -font $boldFontN
  pack .com.t.min -side left -pady 5 -padx 5

  entry .com.t.emin -width 10 -relief sunken \
           -textvariable stmin -font $textFont
  pack .com.t.emin -side left -pady 5 -padx 5

  label .com.t.max -text tmax -font $boldFontN
  pack .com.t.max -side left -pady 5 -padx 5

  entry .com.t.emax -width 10 -relief sunken \
           -textvariable stmax -font $textFont
  pack .com.t.emax -side left -pady 5 -padx 5
}


frame .com.x
pack .com.x

label .com.x.min -text xmin -font $boldFontN
pack .com.x.min -side left -pady 5 -padx 5

entry .com.x.emin -width 10 -relief sunken \
           -textvariable sxmin -font $textFont
pack .com.x.emin -side left -pady 5 -padx 5

label .com.x.max -text xmax -font $boldFontN
pack .com.x.max -side left -pady 5 -padx 5

entry .com.x.emax -width 10 -relief sunken \
           -textvariable sxmax -font $textFont
pack .com.x.emax -side left -pady 5 -padx 5

frame .com.y
pack .com.y

label .com.y.min -text ymin -font $boldFontN
pack .com.y.min -side left -pady 5 -padx 5

entry .com.y.emin -width 10 -relief sunken \
           -textvariable symin -font $textFont
pack .com.y.emin -side left -pady 5 -padx 5

label .com.y.max -text ymax -font $boldFontN
pack .com.y.max -side left -pady 5 -padx 5

entry .com.y.emax -width 10 -relief sunken \
           -textvariable symax -font $textFont
pack .com.y.emax -side left -pady 5 -padx 5




frame .com.file
pack .com.file  -anchor e -pady 10 -padx 10


button .com.file.clr -text {Cancel} -font $boldFontN \
       -command {destroy .com; $ovc.right.misc.scale configure -state normal}
pack .com.file.clr -side left

button .com.file.ok -text {Apply} -font $boldFontN \
       -command {

        set mint [formatpar $stmin]
        set maxt [formatpar $stmax]
        set minx [formatpar $sxmin]
        set maxx [formatpar $sxmax]
        set miny [formatpar $symin]
        set maxy [formatpar $symax]
	destroy .com
	destroy $ovc
	switch $toolflag {
	  "plot" {plotControl;$ovc.right.misc.tp invoke}
	  "slope" {slopeControl;$ovc.left.er.calc invoke}
	}

       }
pack .com.file.ok -side left


}

